---
title: 'HTML attribute: step'
slug: Web/HTML/Attributes/step
tags:
  - Attribute
  - Attributes
  - constrain validation
  - step
---
<p>{{HTMLSidebar}}{{draft}}</p>

<p><span class="seoSummary">The <strong><code>step</code></strong> attribute is a number that specifies the granularity that the value must adhere to or the keyword <code>any</code>. It is valid for the numeric input types, including the {{HTMLElement("input/date", "date")}}, {{HTMLElement("input/month", "month")}}, {{HTMLElement("input/week", "week")}}, {{HTMLElement("input/time", "time")}}, {{HTMLElement("input/datetime-local", "datetime-local")}}, {{HTMLElement("input/number", "number")}} and {{HTMLElement("input/range", "range")}} types.</span></p>

<p>The <code>step</code> sets the <em>stepping interval</em> when clicking up and down spinner buttons, moving a slider left and right on a range, and validating the different date types. If not explicitly included, <code>step</code> defaults to 1 for <code>number</code> and <code>range</code>, and 1 unit type (minute, week, month, day) for the date/time input types. The value can must be a positive number - integer or float -- or the special value <code>any</code>, which means no stepping is implied, and any value is allowed (barring other constraints, such as <code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code> and <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code>).</p>

<p>The default stepping value for <code>number</code> inputs is 1, allowing only integers to be entered, <em>unless</em> the stepping base is not an integer. The default stepping value for <code>time</code> is 1 second, with 900 being equal to 15 minutes.</p>

<table class="standard-table">
 <caption>Default values for step</caption>
 <thead>
  <tr>
   <th>Input type</th>
   <th>Value</th>
   <th>Example</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{HTMLElement("input/date", "date")}}</td>
   <td>1 (day)</td>
   <td><code class="brush: html">&lt;input type="date" min="2019-12-25" step="1"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/month", "month")}}</td>
   <td>1 (month)</td>
   <td><code class="brush: html">&lt;input type="month" min="2019-12" step="12"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/week", "week")}}</td>
   <td>1 (week)</td>
   <td><code class="brush: html">&lt;input type="week" min="2019-W23" step="2"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/time", "time")}}</td>
   <td>60 (seconds)</td>
   <td><code class="brush: html">&lt;input type="time" min="09:00" step="900"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/datetime-local", "datetime-local")}}</td>
   <td>1 (day)</td>
   <td>
    <p><code class="brush: html">&lt;input type="datetime-local" min="019-12-25T19:30" step="7"&gt;</code></p>
   </td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/number", "number")}}</td>
   <td>1</td>
   <td><code class="brush: html">&lt;input type="number" min="0" step="0.1" max="10"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/range", "range")}}</td>
   <td>1</td>
   <td><code class="brush: html">&lt;input type="range" min="0" step="2" max="10"&gt;</code></td>
  </tr>
 </tbody>
</table>

<p>If <code>any</code> is not explicity set, valid values for the <code>number</code>, date/time input types, and <code>range</code> input types are equal to the basis for stepping - the <code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code> value and increments of the step value, up to the <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code> value, if specified. For example, if we have <code>&lt;input type="number" min="10" step="2"&gt;</code> any even integer, 10 or great, is valid. If omitted, <code>&lt;input type="number"&gt;</code>, any integer is valid, but floats, like 4.2, are not valid, as <code>step</code> defaults to 1. For 4.2 to be valid, <code>step</code> would have had to be set to <code>any</code>, 0.1, 0.2, or any the min value would have had to be a number ending in .2, such as <code>&lt;input type="number" min="-5.2"&gt;</code></p>

<h3 id="min_impact_on_step">min impact on step</h3>

<p>The value of <code>min</code> and <code>step</code> define what are valid values, even if the <code>step</code> attribute is not included, as <code>step</code> defaults to <code>0</code>.</p>

<p>We add a big red border around invalid inputs:</p>

<pre class="brush: css notranslate">input:invalid {
  border: solid red 3px;
}</pre>

<p>Then define an input with a minimum value of 7.2, omitting the step attribute, wherein it defaults to 1.</p>

<pre class="brush: html notranslate">&lt;input id="myNumber" name="myNumber" type="number" step="2" min="1.2"&gt;</pre>

<p>Valid values include <code>1.2</code>, <code>3.2</code>, <code>5.2</code>, <code>7.2</code>, <code>9.2</code>, <code>11.2</code>, and so on. Integers and even numbers follwed by .2 are not valid. As we included an invalid value, supporting browsers will show the value as invalid. The number spinner, if present, will only show valid float values of <code>1.2</code> and greater</p>

<p>{{EmbedLiveSample("min_impact_on_step",200,55)}}</p>

<div class="note">
<p><strong>Note:</strong> When the data entered by the user doesn't adhere to the stepping configuration, the value is considered invalid in constraint validation and will match the {{cssxref(":invalid")}} and {{cssxref(":out-of-range")}} pseudoclasses</p>
</div>

<p>See <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">Client-side validation</a> and {{domxref("ValidityState.stepMismatch", "stepMismatch")}} for more information.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Provide instructions to help users understand how to complete the form and use individual form controls. Indicate any required and optional input, data formats, and other relevant information. When using the min attribute, ensure this minimum requirement is understood by the user. Providing instructions within the {{htmlelement('label')}} may be sufficient. If providing instructions outside of labels, which allows more flexible positioning and design, consider using  <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">aria-labelledby</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute">aria-describedby</a></code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'input.html#the-step-attribute', 'step attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'input.html#the-step-attribute', 'step attribute')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code></li>
 <li><a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">constraint validation</a></li>
 <li>{{domxref('Constraint validation', "", 1)}} API</li>
 <li>{{domxref('validityState.stepMismatch')}}</li>
 <li>{{cssxref(':out-of-range')}}</li>
 <li>{{htmlelement('input')}}</li>
</ul>
